using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.pcl;

#nullable enable

public class Wafer
{

    public Wafer(string date, string id, string comments, string sort, string lPDCount, string lPDCM2, string bin1, string bin2, string bin3, string bin4, string bin5, string bin6, string bin7, string bin8, string mean, string stdDev, string areaCount, string areaTotal, string scratchCount, string scratchTotal, string sumOfDefects, string hazeRegion, string hazeAverage, string hazePeak, string laser, string gain, string diameter, string thresh, string exclusion, string hazeRng, string thruput, string recipe)
    {
        Date = date;
        Id = id;
        Comments = comments;
        Sort = sort;
        LPDCount = lPDCount;
        LPDCM2 = lPDCM2;
        Bin1 = bin1;
        Bin2 = bin2;
        Bin3 = bin3;
        Bin4 = bin4;
        Bin5 = bin5;
        Bin6 = bin6;
        Bin7 = bin7;
        Bin8 = bin8;
        Mean = mean;
        StdDev = stdDev;
        AreaCount = areaCount;
        AreaTotal = areaTotal;
        ScratchCount = scratchCount;
        ScratchTotal = scratchTotal;
        SumOfDefects = sumOfDefects;
        HazeRegion = hazeRegion;
        HazeAverage = hazeAverage;
        HazePeak = hazePeak;
        Laser = laser;
        Gain = gain;
        Diameter = diameter;
        Thresh = thresh;
        Exclusion = exclusion;
        HazeRng = hazeRng;
        Thruput = thruput;
        Recipe = recipe;
    }

    public string Date { get; }
    public string Id { get; }
    public string Comments { get; }
    public string Sort { get; }
    public string LPDCount { get; }
    public string LPDCM2 { get; }
    public string Bin1 { get; }
    public string Bin2 { get; }
    public string Bin3 { get; }
    public string Bin4 { get; }
    public string Bin5 { get; }
    public string Bin6 { get; }
    public string Bin7 { get; }
    public string Bin8 { get; }
    public string Mean { get; }
    public string StdDev { get; }
    public string AreaCount { get; }
    public string AreaTotal { get; }
    public string ScratchCount { get; }
    public string ScratchTotal { get; }
    public string SumOfDefects { get; }
    public string HazeRegion { get; }
    public string HazeAverage { get; }
    public string HazePeak { get; }
    public string Laser { get; }
    public string Gain { get; }
    public string Diameter { get; }
    public string Thresh { get; }
    public string Exclusion { get; }
    public string HazeRng { get; }
    public string Thruput { get; }
    public string Recipe { get; }

    internal static ReadOnlyCollection<Wafer> Get(string headerFileName, Dictionary<string, string> pages, Constant constant)
    {
        List<Wafer> results = new();
        Wafer wafer;
        string? text;
        List<string> stringList;
        int[] i = new int[] { 0 };
        foreach (KeyValuePair<string, string> keyValuePair in pages)
        {
            if (keyValuePair.Key == headerFileName)
                continue;
            if (!pages.ContainsKey(keyValuePair.Key))
                throw new Exception();
            i[0] = 0;
            stringList = new();
            if (!pages.TryGetValue(keyValuePair.Key, out text))
                throw new Exception();
            Header.ScanPast(text, i, constant.Date);
            string date = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "ID#");
            string id = Header.GetToEOL(text, i);
            if (id.Length > 5)
                id = string.Concat(id.Substring(0, 5), "... - ***");
            id = id.Replace("*", "");
            Header.ScanPast(text, i, "Comments:");
            string comments = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Sort:");
            string sort = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "LPD Count:");
            string lPDCount = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "LPD / cm2:");
            string lPDCM2 = Header.GetToEOL(text, i);
            while (Header.GetBefore(text, i, ":").Contains("Bin"))
                stringList.Add(Header.GetToEOL(text, i));
            string bin1 = stringList.Count >= 1 ? stringList[0] : string.Empty;
            string bin2 = stringList.Count >= 2 ? stringList[1] : string.Empty;
            string bin3 = stringList.Count >= 3 ? stringList[2] : string.Empty;
            string bin4 = stringList.Count >= 4 ? stringList[3] : string.Empty;
            string bin5 = stringList.Count >= 5 ? stringList[4] : string.Empty;
            string bin6 = stringList.Count >= 6 ? stringList[5] : string.Empty;
            string bin7 = stringList.Count >= 7 ? stringList[6] : string.Empty;
            string bin8 = stringList.Count >= 8 ? stringList[7] : string.Empty;
            string mean = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Std Dev:");
            string stdDev = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Area Count:");
            string areaCount = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Area Total:");
            string areaTotal = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Scratch Count:");
            string scratchCount = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Scratch Total:");
            string scratchTotal = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Sum of All Defects:");
            string sumOfDefects = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Haze Region:");
            string hazeRegion = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Haze Average:");
            string hazeAverage = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Haze Peak:");
            string hazePeak = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Laser:");
            string laser = Header.GetBefore(text, i, "Gain:");
            string gain = Header.GetBefore(text, i, "Diameter:");
            string diameter = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Thresh:");
            string thresh = Header.GetBefore(text, i, "Exclusion:");
            string exclusion = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Haze Rng:");
            string hazeRng = Header.GetBefore(text, i, "Thruput:");
            string thruput = Header.GetToEOL(text, i);
            Header.ScanPast(text, i, "Recipe ID:");
            string recipe = Header.GetToEOL(text, i);
            wafer = new(date: date,
                        id: id,
                        comments: comments,
                        sort: sort,
                        lPDCount: lPDCount,
                        lPDCM2: lPDCM2,
                        bin1: bin1,
                        bin2: bin2,
                        bin3: bin3,
                        bin4: bin4,
                        bin5: bin5,
                        bin6: bin6,
                        bin7: bin7,
                        bin8: bin8,
                        mean: mean,
                        stdDev: stdDev,
                        areaCount: areaCount,
                        areaTotal: areaTotal,
                        scratchCount: scratchCount,
                        scratchTotal: scratchTotal,
                        sumOfDefects: sumOfDefects,
                        hazeRegion: hazeRegion,
                        hazeAverage: hazeAverage,
                        hazePeak: hazePeak,
                        laser: laser,
                        gain: gain,
                        diameter: diameter,
                        thresh: thresh,
                        exclusion: exclusion,
                        hazeRng: hazeRng,
                        thruput: thruput,
                        recipe: recipe);
            results.Add(wafer);
        }
        return results.AsReadOnly();
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Wafer))]
internal partial class WaferSourceGenerationContext : JsonSerializerContext
{
}